package com.iformall.controller;

import com.iformall.common.ErrorCode;
import com.iformall.domain.po.WxMerchantBUser;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.*;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;

import com.iformall.domain.po.PosOrder;
import com.iformall.service.PosOrderService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;


@RestController
@RequestMapping("/api/posOrder")
@AllArgsConstructor
@Api(description = "POS订单接口")
public class PosOrderController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());


    private final PosOrderService posOrderService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    public ResultData list(@ModelAttribute PosOrder posOrder, Integer pageNum, Integer pageSize) {
        if (null == posOrder) posOrder = new PosOrder();
        final PageInfo<PosOrder> page = posOrderService.listAsPage(posOrder, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation(value = "新增POS订单接口", notes = "")
    @PostMapping("addForPosPay")
    public ResultData add(@RequestBody PosOrder posOrder) {
        WxMerchantBUser user = getUser();
        if (posOrder == null) {
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL);
        }
        if (posOrder.getType() == null) {
            String errMessage = "订单类型为空";
            logger.error(errMessage);
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), errMessage);
        }
        if (posOrder.getPaymentType() == null) {
            String errMessage = "支付类型为空";
            logger.error(errMessage);
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), errMessage);
        }
        if (posOrder.getPayment() == null) {
            String errMessage = "支付金额为空";
            logger.error(errMessage);
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), errMessage);
        }

        posOrder.setTenantId(user.getTenantId());
        posOrder.setBuUserId(user.getId());
        posOrderService.saveOrUpdate(posOrder);
        return new ResultData(posOrder);
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    public ResultData update(@RequestBody PosOrder posOrder) {
        posOrderService.saveOrUpdate(posOrder);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData delete(Long id) {
        posOrderService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData findById(Long id) {
        return new ResultData(Result.SUCCESS, "查询成功", posOrderService.getById(id));
    }


}
